unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqlite3conn, sqldb, DB, FileUtil, Forms, Controls,
  Graphics, Dialogs, DBGrids, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Memo1: TMemo;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  SQLite3Connection1.DatabaseName := 'A.db';
  SQLite3Connection1.Transaction := SQLTransaction1;

  SQLTransaction1.DataBase := SQLite3Connection1;

  SQLQuery1.DataBase := SQLite3Connection1;
  SQLQuery1.Transaction := SQLTransaction1;
  SQLQuery1.SQL.Text := 'SELECT * FROM Student';

  DataSource1.DataSet := SQLQuery1;
  DBGrid1.DataSource := DataSource1;

  SQLite3Connection1.Open;
  if SQLite3Connection1.Connected then
  begin
    Label1.Caption := 'connected -great';
    SQLQuery1.Open;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SQLQuery1.Close;
  SQLQuery1.SQL.Text := Edit1.Text;
  SQLQuery1.Open;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  // Not now needed - we will use SQLQuery1 instead
  //SQLTransaction1.Commit;
  //SQLTransaction1.StartTransaction;
  //SQLite3Connection1.ExecuteDirect(Edit2.Text);
  //SQLTransaction1.Commit;

  SQLQuery1.Close;
  SQLQuery1.SQL.Text:= Edit2.Text;
  SQLQuery1.ExecSQL;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  SQLQuery1.Close;
  SQLQuery1.SQL.Text:='SELECT * FROM Student';
  SQLQuery1.Open;
  while not SQLQuery1.EOF do
  begin
    Memo1.Lines.Add(
    ' ID: ' + SQLQuery1.FieldByName('StudentID').AsString +
    ' First name: ' + SQLQuery1.FieldByName('First').AsString +
    ' Second name: ' + SQLQuery1.FieldByName('Second').AsString);
    SQLQuery1.Next;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF UNIX}// Linux
    {$IFNDEF DARWIN}
  SQLiteLibraryName := './libsqlite3.so';
    {$ENDIF}
  {$ENDIF}

  {$IFDEF WINDOWS}// Windows
  SQLiteLibraryName := 'sqlite3.dll';
  {$ENDIF}
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  // SQLQuery1.Close;

end;

end.

